#!/usr/local/bin/forth

.( GUI.fr - loading gui test words ) cr cr


0 value fld1
0 value fld1-txt
0 value fld2

\ *************************************************
\ Declare callback functions
\ *************************************************

: cb-win ." Main callback - widget " . cr ;

\ ' cb-win hex .( cb-win is at ) . decimal cr

: cb-new drop ." File/new" cr ;
: cb-exit drop bye ;
: cb-edit drop ." Edit" cr ;

\ Button 0 callback
: cb-but0 { but }
	." But0 state is " but but-state . cr
;

\ Button 1 callback
: cb-but1 { but | txt }
	fld2 field-gettext to txt
	." Entered text: '" txt $> ." '" cr
	txt $" q" strcmp not if
		bye
	endif
	fld1-txt $" \n" $+ txt $+ to fld1-txt
\	fld1 fld1-txt field-settext
	fld1 $" \n" field-display-append
	fld1 txt field-display-append
	fld2 0 field-settext
;

\ Button 2 callback
: cb-but2 { but }
	." But2 state is " but but-state . cr
;

: cb-quit bye ;

\ **********************************************
\ Menu Declarations
\ **********************************************

menu-dec
$" File" 0 0 0 menu-item
	submenu
		$" New"  0 ' cb-new  0 menu-item
		$" Exit" 0 ' cb-exit 0 menu-item
	submenu-end
	$" Edit"   0 ' cb-edit 0 menu-item
menu-end constant menuitems

\ **********************************************
\ Start window creation
\ **********************************************

0 1 220 220 $" This window 2" win-new value pwin

	\ add the menu bar
    menuitems 0 0 220 20 win-menu

	\ add a box
\	20 40 180 80 $" This label" box-new \ ( -- pBox )
\		dup box-oval draw-style
\		dup 36 label-size
\		dup bold italic timesfont + + label-font
\		dup label-shadow label-type
\		dup 0 label-align
\		dup 255 200 0 color-mix color
\		dup red label-color
\		drop

    \ add scroll region
    0 20 pwin width pwin height 20 - 0 scroll-new value scrl
    pwin yellow color
    scrl yellow color
    
	\ a display field
	5 25 205 120 0 field-display-new to fld1
	fld1 white label-color
	fld1 white color
	fld1 $"  " field-display-append
	fld1 5 display-scroll-width
	
	\ a label for text field
	fld1 below 80 20 $" Enter#" box-new value static1

	\ add a text field
	static1 beside 100 20 0 field-new to fld2
	fld2 white label-color

	\ add a couple of buttons

	static1 below 50 20 $" But0" but-new-light constant but0
	but0 but-toggle but-type
	but0 blue color
	but0 white label-color
	but0 italic label-font
	but0 255 200 0 color-mix selection-color
	but0 ' cb-but0 set-callback

	but0 beside 50 20 $" But1" but-new-return constant but1
	but1 box-rounded draw-style
	but1 ' cb-but1 set-callback

	but1 beside 50 20 $" But2" but-new-check constant but2
	but2 but-toggle but-type
	but2 red color 
	but2 255 200 0 color-mix label-color
	but2 9 label-size
	but2 ' cb-but2 set-callback

	but2 beside 40 20 $" Quit" but-new constant but-quit
	but-quit dup white color dup 9 label-size ' bye set-callback

    scrl scroll-end
    scrl resizable
    
    \ pwin ' cb-win set-callback
    pwin resizable

pwin win-end

fld2 $" This is a field" field-settext

: dogui
	pwin win-show
	pwin 0 0 220 220 win-resize
	fld1 $"  " field-display-append
	gui-waitclose
	gui-flush
;

\ dogui
